#!/usr/bin/perl

package RPM::Source::Transformation::Component;

use strict;
use warnings;
use Carp;
no strict "refs";
#use RPM::Source::Transform;
use RPM::Source::Transformation::OptHandlerWrapper;

our $VERSION=0.02;

use Exporter 'import';
our @EXPORT = qw(TRANSFORMATION_FAILURE TRANSFORMATION_OK
PRIORITY_AT_BEGIN
PRIORITY_POST_BEGIN
PRIORITY_PREHOOKS
PRIORITY_PRECONVERT
PRIORITY_CONVERT
PRIORITY_POSTCONVERT
PRIORITY_HOOKS
PRIORITY_POSTHOOKS
PRIORITY_COMMANDLINE
PRIORITY_DEFAULT
PRIORITY_PRERELEASE
PRIORITY_AT_END
);

use constant {
	TRANSFORMATION_FAILURE	=> 101,
	TRANSFORMATION_OK	=> 0,

	PRIORITY_AT_BEGIN	=> 90,
	PRIORITY_POST_BEGIN	=> 80,
	PRIORITY_PREHOOKS	=> 70,
	PRIORITY_PRECONVERT	=> 60,
	PRIORITY_CONVERT	=> 50,
	PRIORITY_POSTCONVERT	=> 40,
	PRIORITY_HOOKS		=> 30,
	PRIORITY_POSTHOOKS	=> 20,
	PRIORITY_COMMANDLINE	=> 10,
	PRIORITY_DEFAULT	=> 0,
	PRIORITY_PRERELEASE	=> -10,
	PRIORITY_AT_END		=> -20,
};

sub new {
    my $class = shift;
    my $self = {
	@_
    };
    bless $self, $class;
    return $self;
}

sub longopt_usage {}

sub get_longopt {
    my $self=shift;
    $self = ref $self if ref $self;
    my $longopt_stringref="${self}::LONGOPT";
    my $longopt_ref=*{$longopt_stringref}{ARRAY};
    return unless $longopt_ref;
    return @$longopt_ref;
}

sub process_options {}
sub register_messages {}

# TODO: Factory subclass?
sub init_factory {}
sub transformations {
    return;
}

sub add_opt {
    my ($extopt,$intopt)=@_;
    ### TODO: use some fixed keys hash here
    while (my ($key, $val)=each (%$intopt)) {
	warn "Option conflict for $key: already $extopt->{$key}" if defined $extopt->{$key};
	$extopt->{$key}=$val;
    }
}

1;
