package RPM::Source::Transformation::DefaultPlayer;

use strict;
use warnings;
use Carp;

use RPM::Source::Transformation::Component;
our @ISA=qw/RPM::Source::Transformation::Component/;

#push @RPM::Source::Transform::SUPPORT_CLASSES, __PACKAGE__;
#$RPM::Source::Transform::PLAYER=__PACKAGE__;

our $verbose=0;

sub apply_collection {
    my (undef,$spec,$parent,$opt,$resourceobj,$actions)=@_;
    foreach my $transformation ($actions->get) {
	my $exit_code=$transformation->apply($spec,$parent,$opt,$resourceobj);
	if ($exit_code == RPM::Source::Transformation::Component::TRANSFORMATION_FAILURE) {
	    return RPM::Source::Transformation::Component::TRANSFORMATION_FAILURE;
	} elsif (not defined $exit_code or $exit_code != RPM::Source::Transformation::Component::TRANSFORMATION_OK) {
	    warn "transformation '$transformation->{-name}' returned invalid exit code\n";
	}
    }
    return RPM::Source::Transformation::Component::TRANSFORMATION_OK;
}

1;
